<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 4/17/17
 * Time: 5:51 PM
 *
 * Check: CODING.md > Download
 */

namespace qfq;

use qfq;

require_once(__DIR__ . '/../core/report/Download.php');
require_once(__DIR__ . '/../core/Constants.php');
require_once(__DIR__ . '/../core/exceptions/DownloadException.php');
require_once(__DIR__ . '/../core/exceptions/CodeException.php');
require_once(__DIR__ . '/../core/exceptions/DbException.php');
require_once(__DIR__ . '/../core/exceptions/ErrorHandler.php');


set_error_handler("\\qfq\\ErrorHandler::exception_error_handler");

$output = '';

try {
    try {
        $download = new Download();

        // If all is fine: process() will output file via print() !!
        $output = $download->process(STORE_SIP, OUTPUT_MODE_DIRECT);

    } catch (qfq\CodeException $e) {
        $output = $e->formatMessage();
    } catch (qfq\DbException $e) {
        $output = $e->formatMessage();
    } catch (qfq\DownloadException $e) {
        $output = $e->formatMessage();
    }
} catch (\Exception $e) {
    $output = "Exception: " . $e->getMessage();
}

echo $output;
